From 7f24e754b043838f6e014be4232dfe6682ab78bc Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?=E4=BD=99=E6=98=8C=E5=B9=B3?= <yuchangping@deepin.com>
Date: Mon, 1 Jun 2020 15:24:05 +0800
Subject: [PATCH] gdiplus: keep temporary dc for some need, like ali wangwang
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

When quick call GdipGetDC then call GdipReleaseDC, now call 
GdipCreateFontFromLogfontA need the front dc, but wine will 
delete the temporary dc.

Signed-off-by: Changping Yu <yuchangping@deepin.com>
---
 dlls/gdiplus/graphics.c | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

diff --git a/dlls/gdiplus/graphics.c b/dlls/gdiplus/graphics.c
index 3ea37c6476..3dfece716a 100644
--- a/dlls/gdiplus/graphics.c
+++ b/dlls/gdiplus/graphics.c
@@ -2518,6 +2518,9 @@ GpStatus WINGDIPAPI GdipDeleteGraphics(GpGraphics *graphics)
 
     DeleteObject(graphics->gdi_clip);
 
+    if(graphics->temp_hdc)
+        DeleteDC(graphics->temp_hdc);
+
     /* Native returns ObjectBusy on the second free, instead of crashing as we'd
      * do otherwise, but we can't have that in the test suite because it means
      * accessing freed memory. */
@@ -6717,6 +6720,9 @@ GpStatus WINGDIPAPI GdipGetDC(GpGraphics *graphics, HDC *hdc)
         SelectObject(temp_hdc, hbitmap);
 
         graphics->temp_hbitmap = hbitmap;
+        if(graphics->temp_hdc)
+            DeleteDC(graphics->temp_hdc);
+
         *hdc = graphics->temp_hdc = temp_hdc;
     }
     else
@@ -6765,9 +6771,7 @@ GpStatus WINGDIPAPI GdipReleaseDC(GpGraphics *graphics, HDC hdc)
             graphics->temp_hbitmap_width * 4, PixelFormat32bppARGB);
 
         /* Clean up. */
-        DeleteDC(graphics->temp_hdc);
         DeleteObject(graphics->temp_hbitmap);
-        graphics->temp_hdc = NULL;
         graphics->temp_hbitmap = NULL;
     }
     else if (hdc != graphics->hdc)
-- 
2.26.1.windows.1

